package com.qa.utilities;

import java.io.File;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.transform.OutputKeys;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import com.qa.utilities.Util;


public class ParseXML {
	private Util util =new Util();
	Document doc= null;
	NodeList nList;
	
//Read the XML file
	public void  ReadXMLFileFromLocal(File file) {

		try {

			DocumentBuilderFactory dbFactory = DocumentBuilderFactory.newInstance();
			DocumentBuilder dBuilder = dbFactory.newDocumentBuilder();
			doc = dBuilder.parse(file);
		}
		catch(Exception e)
		{ e.printStackTrace();}



	}

	//Get the Root Tag Staff from the XML file
	public void getXMLNodes() 
	{
		doc.getDocumentElement().normalize();
		System.out.println("Root element :" + doc.getDocumentElement().getNodeName());
		nList = doc.getElementsByTagName("staff");
	}

	public void UpdateXMLContent()
	{
		//Read all the sub nodes from the root Node staff
		for (int temp = 0; temp < nList.getLength(); temp++) {
			Node nNode = nList.item(temp);
			System.out.println("\nCurrent Element :" + nNode.getNodeName());

			if (nNode.getNodeType() == Node.ELEMENT_NODE) {
                //Prints all the sub nodes
				Element eElement = (Element) nNode;
				System.out.println("Staff id : " + eElement.getAttribute("id"));
				System.out.println("First Name : " + eElement.getElementsByTagName("firstname").item(0).getTextContent());
				System.out.println("Last Name : " + eElement.getElementsByTagName("lastname").item(0).getTextContent());
				System.out.println("Nick Name : " + eElement.getElementsByTagName("nickname").item(0).getTextContent());
				System.out.println("Salary : " + eElement.getElementsByTagName("salary").item(0).getTextContent());
				System.out.println("----------------------------");
				
				//Updates the Firstname node
				Node firstNameNode = eElement.getElementsByTagName("firstname").item(0).getFirstChild();
				firstNameNode.setNodeValue("GHI");
			
					try
					{       
						//Writes the new content to the XML file
					        doc.getDocumentElement().normalize();
					        TransformerFactory transformerFactory = TransformerFactory.newInstance();
					        Transformer transformer = transformerFactory.newTransformer();
					        DOMSource source = new DOMSource(doc);
					        StreamResult result = new StreamResult(new File("/Users/nisum/eclipse-workspace/Cuke/Cucumber-SpringBoot-Nisum_Practise-Projects/ParseJSONProject/sample.xml"));
					        transformer.setOutputProperty(OutputKeys.INDENT, "yes");
					        transformer.transform(source, result);
					        System.out.println("XML file updated successfully");
					    }
					catch(Exception e)
					{
						e.printStackTrace();
					}

               
			}

		}
	}
		
		


}














